unit U_Principal;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, ImgList, StdCtrls, ExtCtrls, ExtDlgs,inifiles,Registry;

type
  TForm1 = class(TForm)
    Image1: TImage;
    od_imagem: TOpenPictureDialog;
    Edit1: TEdit;
    Edit2: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Bevel1: TBevel;
    Button1: TButton;
    ImageList1: TImageList;
    PopupMenu1: TPopupMenu;
    abir1: TMenuItem;
    Apagar1: TMenuItem;
    Cancelar1: TMenuItem;
    Bevel2: TBevel;
    Memo1: TMemo;
    Label3: TLabel;
    procedure abir1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

// Esta cambia el alto y ancho, estirando la imagen si es necesario
procedure Redimensionar(Imagen: TGraphic; Ancho, Alto: Integer);
var
  Bitmap: TBitmap;
begin
  Bitmap:= TBitmap.Create;
  try
    Bitmap.Width:= Ancho;
    Bitmap.Height:= Alto;
    Bitmap.Canvas.StretchDraw(Bitmap.Canvas.ClipRect,Imagen);
    Imagen.Assign(Bitmap);
  finally
    Bitmap.Free;
  end;
end;

// Esta otra mantiene la relacion entre alto y ancho
procedure Proporcional(Imagen: TGraphic; Ancho, Alto: Integer);
var
  Bitmap: TBitmap;
begin
  Bitmap:= TBitmap.Create;
  try
    if  (Ancho/Imagen.Width) < (Alto/Imagen.Height) then
      Alto:= Trunc((Ancho*Imagen.Height)/Imagen.Width)
    else
      Ancho:= Trunc((Imagen.Width*Alto)/Imagen.Height);
    Bitmap.Width:= Ancho;
    Bitmap.Height:= Alto;
    Bitmap.Canvas.StretchDraw(Bitmap.Canvas.ClipRect,Imagen);
    Imagen.Assign(Bitmap);
  finally
    Bitmap.Free;
  end;
end;

function caminho:string;
var
registro:TRegistry;
begin
  registro := TRegistry.Create;
       registro.RootKey := HKEY_LOCAL_MACHINE;
       registro.OpenKey('SOFTWARE\Microsoft\Windows NT\CurrentVersion',false);
     Result := registro.ReadString('SystemRoot');
  registro.Free;
end;

procedure TForm1.abir1Click(Sender: TObject);
begin
  if od_imagem.Execute then
     Image1.Picture.LoadFromFile(od_imagem.FileName);
end;

procedure TForm1.Button1Click(Sender: TObject);
var
Bmp: TBitmap;
I:Integer;
ArqIni : TIniFile;
begin

if (Edit1.Text <> '') and (Edit2.Text <> '') then
   //deleta arquivo ini
    if FileExists(caminho+'\System32\Oeminfo.ini') then
    begin
    DeleteFile(caminho+'\System32\Oeminfo.ini');
    end;

    Bmp:= TBitmap.Create;
    ArqIni := TIniFile.Create(caminho+'\System32\Oeminfo.ini');
    try

    if od_imagem.FileName <> '' then
    begin
    // redimenciona e salva a logo
    Bmp.LoadFromFile(od_imagem.FileName);
    Proporcional(Bmp,Image1.Height *3 div 2,Image1.Width * 3 div 2 );
    Bmp.SaveToFile(caminho+'\System32\Oemlogo.bmp');
    end;

    // gera arquivo ini primrio do geral
    ArqIni.WriteString('General', 'Manufacturer',Edit1.Text);
    ArqIni.WriteString('General', 'Modelo', Edit2.Text);

    // verifica quantas linhas foram digitadas
    for I := 1 to Memo1.Lines.Count do
    begin
    ArqIni.WriteString('Support Information', 'Line'+IntToStr(I), Memo1.Lines[I-1]);
    end;

    // Finaliza tudo
    Finally
    ArqIni.Free;
    Bmp.Free;
    Application.MessageBox('Logo criado com sucesso.','Criao bem Sucessida!',MB_ICONINFORMATION);
   end;
end;

end.
